#!ruby -Ke
#
#  TOPPRES/A-CAN
#      Automotive CAN
#
#  Copyright (C) 2013-2014 by FUJI SOFT INCORPORATED, JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
#  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
#  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
#  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
#  $Id: check_target_spec_coverage.rb 913 2014-12-26 06:08:05Z shigihara $
#

#
#  ޥ¸ΥλͥФ
#

if ($0 == __FILE__)
  TOOL_ROOT = File.expand_path(File.dirname(__FILE__) + "/")
  $LOAD_PATH.unshift(TOOL_ROOT)
end

require "pp"

# ¸Ͱե
sNonDependSpecFile = "#{TOOL_ROOT}/implementation/impl_spec_id.txt"

# ¸оݥեǡ
hTargetFiles = {"hsbv850e2fg4_cx" => ["#{TOOL_ROOT}/../arch/fcn/Can_Prc.h", "#{TOOL_ROOT}/../arch/fcn/Can_Prc.tf"],
                "nios2_dev_gcc" => []}
hTargetFiles.each{|sName, aFiles|
  aFiles.push("#{TOOL_ROOT}/../target/#{sName}/Can_Irq.c")
  aFiles.push("#{TOOL_ROOT}/../target/#{sName}/Can_Target.h")
  aFiles.push("#{TOOL_ROOT}/../target/#{sName}/Can_Target.tf")
}

# ¸Ͱ
sFileData = File.read(sNonDependSpecFile)
aDependSpec = sFileData.scan(/\((CAN[0-9][0-9][0-9])\)/).flatten()

# ¸˥å
hTargetFiles.each{|sName, aFiles|
  puts("===== #{sName} =====")

  aTargetSpec = []
  aFiles.each{|sFile|
    sFileData = File.read(sFile)
    aTargetSpec.concat(sFileData.scan(/[\[<](CAN[0-9][0-9][0-9])[>\]]/).flatten())
  }

  bChk = false
  nCnt = 0
  aDependSpec.each{|sSpecID|
    if (!aTargetSpec.include?(sSpecID))
      puts(sSpecID)
      nCnt += 1
      bChk = true
    end
  }

  if (bChk == false)
    puts("All spec-id : OK !\n\n")
  else
    puts("-" * 30)
    puts("Above spec-ids(#{nCnt}) are not found !\n\n")
  end
}
